"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.promise.js");

var _react = _interopRequireWildcard(require("react"));

var _reactQuery = require("react-query");

var _Sky = _interopRequireDefault(require("./Sky"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function SolarClock(props) {
  const ref = (0, _react.useRef)(null);
  const [height, setHeight] = (0, _react.useState)(0);
  const [width, setWidth] = (0, _react.useState)(0);
  const [intervalMs, setIntervalMs] = (0, _react.useState)();
  const [dayOrNight, setDayOrNight] = (0, _react.useState)("");
  const lat = 53;
  const lon = -6;
  (0, _react.useEffect)(() => {
    if (ref.current) {
      setHeight(ref.current.parentElement.offsetHeight);
      setWidth(ref.current.parentElement.offsetWidth);
      console.log({
        height,
        width
      });
    }
  });

  const timeSetter = () => {
    if (data === undefined) {
      return "error";
    } // checking whether it is day or night, function returns strings of 
    // day or night respectively


    const timeUnix = new Date();
    const currentTimeSec = Math.floor(timeUnix.getTime() / 1000);
    const timeRespectiveToSunset = data.sys.sunset - currentTimeSec;

    if (timeRespectiveToSunset > 0) {
      return 'daytime';
    } else if (timeRespectiveToSunset < 0) {
      return 'nighttime';
    } // it should never get here, but should it the function will default to 
    // 12hrs for day and night


    return 'error';
  }; // check if its day or night in this function


  const fetchWeatherData = async () => {
    const response = await fetch("https://api.openweathermap.org/data/2.5/weather?lat=53&lon=-7&appid=".concat(props.API));
    return response.json();
  };

  const {
    data,
    status
  } = (0, _reactQuery.useQuery)(["repoData"], fetchWeatherData, {
    refetchInterval: 1000000000,
    staleTime: Infinity
  });
  (0, _react.useEffect)(() => {
    const timerId = setInterval(setDayOrNight(timeSetter), 10000);
    return function cleanup() {
      clearInterval(timerId);
    };
  }, []);

  if (status === "loading") {
    return /*#__PURE__*/_react.default.createElement("div", null, "loading...");
  }

  ; // in the case of an error the 

  if (status === "error") {
    // sets the refetch interval to 1hr
    setIntervalMs(36000000);
    return /*#__PURE__*/_react.default.createElement(_Sky.default, {
      type: "error"
    });
  }

  ; //if the data is returned we set a refetch interval for when the next sunset/sunrise is to refresh the interface

  return /*#__PURE__*/_react.default.createElement("div", {
    ref: ref,
    height: "100%",
    width: "100%"
  }, height > 0 && /*#__PURE__*/_react.default.createElement(_Sky.default, {
    type: dayOrNight,
    sunrise: data.sys.sunrise,
    sunset: data.sys.sunset,
    height: height,
    width: width
  }));
}

var _default = SolarClock;
exports.default = _default;